from __future__ import print_function

run = False

if run:


    import os.path
    import textwrap
    import glob
    from pysd import utils

    test_dir = 'test-models/'
    vensim_test_files = glob.glob(test_dir+'tests/*/*.mdl')

    tests = []
    for file_path in vensim_test_files:
        (path, file_name) = os.path.split(file_path)
        (name, ext) = os.path.splitext(file_name)

        test_name = utils.make_python_identifier(path.split('/')[-1])[0]

        test_func_string = """
            def test_%(test_name)s(self):
                output, canon = runner('%(file_path)s')
                assert_frames_close(output, canon, rtol=rtol)
            """ % {
            'file_path': file_path,
            'test_name': test_name,
        }
        tests.append(test_func_string)

    file_string = textwrap.dedent('''
        """
        Note that this file is autogenerated by `integration_test_factory.py`
        and changes are likely to be overwritten.
        """

        import unittest
        from pysd.tools.benchmarking import runner, assert_frames_close

        rtol = .05


        class TestIntegrationExamples(unittest.TestCase):
        %(tests)s

        ''' % {'tests': ''.join(tests)})

    with open('integration_test_pysd.py', 'w', encoding='UTF-8') as ofile:
        ofile.write(file_string)

    print('generated %i integration tests' % len(tests))
